--
-- Map Function Scripts
-- by Blacky_BPG
--
-- Version 1.0.0 | 20.04.2014 | initial release
-- Version 1.1.0 | 28.04.2014 | added home marker map hotspot for savezone
--

samypoTrigger = {};
local samypoTrigger_mt = Class(samypoTrigger);

function samypoTrigger.onCreate(id)
	g_currentMission:addUpdateable(samypoTrigger:new(id));
end;

function samypoTrigger:new(id, customMt)
	local instance = {};
	if customMt ~= nil then
		setmetatable(instance, customMt);
	else
		setmetatable(instance, samypoTrigger_mt);
	end;

	instance.triggerId = id;
	if g_currentMission:getIsClient() then
		addTrigger(id, "triggerCallback", instance);
	end;

	local x, y, z = getWorldTranslation(id);
	instance.count = 0;
	local iconSize = g_currentMission.missionPDA.pdaMapWidth / 15;
	instance.myHotSpot = g_currentMission.missionPDA:createMapHotspot("MyHotSpot", Utils.getFilename("$dataS2/menu/lan_icon.dds", self.baseDirectory),x,z, iconSize, iconSize * (4 / 3), false, false, false, 0, true);

	instance.isEnabled = true;
	return instance;
end;

function samypoTrigger:delete()
	if self.triggerId ~= nil then
		removeTrigger(self.triggerId);
	end;
	if self.myHotSpot ~= nil then
		g_currentMission.missionPDA:deleteMapHotspot(self.myHotSpot);
	end;
end;

function samypoTrigger:update(dt)
	-- set the override value for single version of samypo
	-- so you can use save position only IN the trigger
	if not g_currentMission.samypoTrigger then
		g_currentMission.samypoTrigger = true;
	end;
end;

function samypoTrigger:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if g_currentMission ~= nil and self.isEnabled then
		if g_currentMission.player ~= nil then
			if g_currentMission.player.rootNode == otherId then
				if onEnter then
					g_currentMission.samypoAllowed = true;
				elseif onLeave then
					g_currentMission.samypoAllowed = false;
				end;
			end;
		end;
	end;
end;

g_onCreateUtil.addOnCreateFunction("samypoTrigger", samypoTrigger.onCreate);
